#ifndef _IFEATURES_H_
#define _IFEATURES_H_
#pragma once
#include <stdio.h>
#include "vec3f.h"
class distree_vertex_t;
class distree_node_t;
class distree_t;
class IFeatures
{
public:
    IFeatures(void);
    virtual ~IFeatures(void);
    virtual void initial_distree_feature_array(distree_t &tree)=0;
    virtual size_t size_feature() const = 0;
    virtual void*  data() = 0;
    virtual bool collect_feature(size_t child_node_index, size_t parent_node_index,
                                    distree_t& tree, bool is_profiling=false) = 0;
    virtual float compute_vertex_feature_distance( distree_vertex_t& cur_vertex,
                                            int feature_index, distree_t& tree )=0;
    virtual float compute_vertex_feature_distance( lily::vec3f& coords,
                                            int feature_index, distree_t& tree )=0;
};
#endif

