#ifndef MarchingCubes_H
#define MarchingCubes_H
#include "vec3f.h"
#include "vec3i.h"
#include "vertex_triangle_t.h"
#include "svector.h"
using namespace lily;

class marching_cube{
protected:
    typedef struct GridCell{
        float val[8];
        vec3f pos[8];
    }GridCell;

public:
    void RenderMarchCube_char(char *data, const vec3i& size,
        const vec3i& gridsize, float isolevel, svector<vertex_triangle_t>& vertices);

    void RenderMarchCube_double(double *data, const vec3i& size, 
        const vec3i& gridsize, float isolevel, svector<vertex_triangle_t>& vertices );

    void RenderMarchCube_float(float *data, const vec3i& size,
        const vec3i& gridsize, float isolevel, svector<vertex_triangle_t>& vertices );

    int Polygonise(GridCell& grid, float isolevel, vec3f *triangles);
};

#endif