#ifndef _FEATURES_GEOMETRY_H_
#define _FEATURES_GEOMETRY_H_

#pragma once
#include "IFeatures.h"
//#include "dutility.h"
#include "vec3i.h"
#include "vec3f.h"
#include "svector.h"
//#include "obj_model_t.h"
#include "triangle_t.h"
#include "dutility.h"

class obj_model_t;

class feature_geometry_t :
    public IFeatures
{
public:
    obj_model_t* m_pobj_model;//shared pointer, not responsible to delete it.
    svector<triangle_t> m_features_triangle;
public:
    feature_geometry_t(void);
    feature_geometry_t(obj_model_t* pobj_model);
    ~feature_geometry_t(void);
    void set_model(obj_model_t* pobj_model){ m_pobj_model = pobj_model;}
    virtual void initial_distree_feature_array( distree_t &tree );

    virtual size_t size_feature() const;

    virtual void* data();

    virtual bool  collect_feature( size_t child_node_index, size_t parent_node_index, distree_t& tree, bool is_profiling=false );

    virtual float compute_vertex_feature_distance( distree_vertex_t& cur_vertex, int feature_index, distree_t& tree );

    virtual float compute_vertex_feature_distance( lily::vec3f& coords, int feature_index, distree_t& tree );

            void  load_geometry_from_binfile( char* filename);
            obj_model_t& get_obj_model(){ return *m_pobj_model;}
            //verify if the local block of current processor pxyz has any geometry.
    virtual color_t contain_local_geometry( const lily::vec3i& pxyz, const lily::vec3i& np_xyz );
    void remove_degenerated_triangle();
    // void gather_local_geometry( color_t &mycolor, distree_t &tree );
};

#endif

