#ifndef _FEATURES_GLOBAL_LEAVES_H_
#define _FEATURES_GLOBAL_LEAVES_H_
#pragma once
#include "IFeatures.h"
#include "svector.h"
#include "BBox.h"

typedef struct distree_global_leaf_t{
    lily::BBox m_bound;//the bbox of global_leaf node
    svector<int>   processor_indices;//PE id which is assigned to this leaf node.
    svector<int>   processor_3x_indices;//PE id in the tripe of leaf node.
    bool   has_feature;//indicate if this isoblock has feature or not.
}distree_global_leaf_t;

class feature_global_leaves_t :
    public IFeatures
{
public:
    svector<distree_global_leaf_t> m_assigned_global_tree_leaf_nodes;
public:
    feature_global_leaves_t(void);
    ~feature_global_leaves_t(void);

    virtual void initial_distree_feature_array( distree_t &tree );

    virtual size_t size_feature() const;

    virtual void* data();

    virtual bool collect_feature( size_t child_node_index, size_t parent_node_index,
                                  distree_t& tree, bool is_profiling=false );
    virtual float compute_vertex_feature_distance( distree_vertex_t& cur_vertex,
                                                    int feature_index, distree_t& tree );
    virtual float compute_vertex_feature_distance( lily::vec3f& coords, int feature_index, distree_t& tree );
};

#endif
