#ifndef _ISOBLOCK_FEATURES_H_
#define _ISOBLOCK_FEATURES_H_
#pragma once
#include "IFeatures.h"
//#include <vector>
#include "BBox.h"
#include "utility.h"
#include "svector.h"

class bitmap_t;

typedef struct distree_isoblock_t{
    lily::BBox m_bound;//the bbox of isoblock
    int    pe_id;//PE id to which this block belongs.
    bool   has_feature;//indicate if this isoblock has feature or not.
}distree_isoblock_t;

class feature_isoblock_t :
    public IFeatures
{

public:
    svector<distree_isoblock_t> m_isoblocks;
private:
    const bitmap_t *bitmap;
public:
    feature_isoblock_t(const bitmap_t* bits);
    virtual ~feature_isoblock_t(void);

    virtual void initial_distree_feature_array( distree_t &tree );

    virtual size_t size_feature() const;

    virtual void*  data(){ return m_isoblocks.data_ptr();};

    virtual bool collect_feature( size_t child_node_index,
                                  size_t parent_node_index,
                                  distree_t& tree, bool is_profiling=false );

    virtual float compute_vertex_feature_distance( distree_vertex_t& cur_vertex,
                                                int feature_index, distree_t& tree );
    virtual float compute_vertex_feature_distance( lily::vec3f& coords,
                                                int feature_index, distree_t& tree );
    virtual void  update_tree(distree_t& tree);

    distree_isoblock_t  operator [](int i) const { return m_isoblocks[i];}
    distree_isoblock_t& operator [](int i) { return m_isoblocks[i];}
};

#endif

