#include <mpi.h>
#include "parallel_test.h"
#include "hpgv_utiltiming.h"
int parallel_test::MY_ALL_SLOVE_TIME           = HPGV_TIMING_UNIT_0;
int parallel_test::CREATE_BITMAP_TIME          = HPGV_TIMING_UNIT_1;
int parallel_test::CREATE_GLOBAL_TREE_TIME     = HPGV_TIMING_UNIT_2;
int parallel_test::CREATE_SCHEDULE_TIME        = HPGV_TIMING_UNIT_4;
int parallel_test::LOCAL_TREE_TIME             = HPGV_TIMING_UNIT_5;
int parallel_test::VERTEX_DISTANCE_TIME        = HPGV_TIMING_UNIT_7;
int parallel_test::ASSIGN_LOCAL_REGION         = HPGV_TIMING_UNIT_3;
int parallel_test::CREATE_VTX_ARRAY            = HPGV_TIMING_UNIT_6;
int parallel_test::COM_MEM_TIME                = HPGV_TIMING_UNIT_8;
int parallel_test::DIST_LOCAL                  = HPGV_TIMING_UNIT_9;
int parallel_test::PREPARE_SEND_BUFFER         = HPGV_TIMING_UNIT_10;
int parallel_test::COMM_PHASE_1                = HPGV_TIMING_UNIT_11;
int parallel_test::COMPUT_REMOTE_DIST          = HPGV_TIMING_UNIT_12;
int parallel_test::COMM_PHASE_2                = HPGV_TIMING_UNIT_13;
int parallel_test::UPDATE_DIST                 = HPGV_TIMING_UNIT_14;
int parallel_test::MY_SEND_BYTE1               = HPGV_TIMING_UNIT_15;
int parallel_test::MY_RECV_BYTE1               = HPGV_TIMING_UNIT_16;
int parallel_test::MY_SEND_BYTE2               = HPGV_TIMING_UNIT_17;
int parallel_test::MY_RECV_BYTE2               = HPGV_TIMING_UNIT_18;
int parallel_test::COMPUTE_DIST_VOL_ALL_TIME   = HPGV_TIMING_UNIT_19;
int parallel_test::COMPUTE_DIST_VOL_STEP_TIME  = HPGV_TIMING_UNIT_20;
int parallel_test::T_g_init                    = HPGV_TIMING_UNIT_21;
int parallel_test::T_g_2                       = HPGV_TIMING_UNIT_22;
int parallel_test::T_g_m                       = HPGV_TIMING_UNIT_23;
int parallel_test::T_g_key                     = HPGV_TIMING_UNIT_24;
int parallel_test::T_g_child                   = HPGV_TIMING_UNIT_25;
int parallel_test::T_g_collect                 = HPGV_TIMING_UNIT_26;
int parallel_test::C_global_tree_h             = HPGV_TIMING_UNIT_27;
int parallel_test::C_global_tree_size          = HPGV_TIMING_UNIT_28;
int parallel_test::T_g_isoblock                = HPGV_TIMING_UNIT_29;
int parallel_test::T_g_proc                    = HPGV_TIMING_UNIT_30;
int parallel_test::LOAD_GEOMETRY_TIME          = HPGV_TIMING_UNIT_31;
int parallel_test::update_time                 = HPGV_TIMING_UNIT_32;
int parallel_test::C_leaf_node_changed         = HPGV_TIMING_UNIT_33;
int parallel_test::C_pe_changed                = HPGV_TIMING_UNIT_34;
int parallel_test::C_update_comm               = HPGV_TIMING_UNIT_35;
int parallel_test::C_nbits_changed             = HPGV_TIMING_UNIT_36;
int parallel_test::T_u_dist                    = HPGV_TIMING_UNIT_37;
size_t parallel_test::C_leaf_node_total        = HPGV_TIMING_UNIT_38;
float parallel_test::rate_isovoxel_change=0.0f;
float parallel_test::rate_leaf_change = 0.0f;
int parallel_test::update_count = 0;

parallel_test::parallel_test(void)
{
}

parallel_test::~parallel_test(void)
{
}
#define RENDER_ROOT 0

bool parallel_test::init_timing_module( char * msg, bool init_timing )
{
    //  initialize timing module
    if (!HPGV_TIMING_VALID()){
        HPGV_TIMING_INIT(RENDER_ROOT, MPI_COMM_WORLD);
    }
    HPGV_TIMING_COUNTROOT(1);
    HPGV_TIMING_SHOWLOCAL(0);
    HPGV_TIMING_SHOWGLOBAL(1);
    HPGV_TIMING_CONTEXTLOCAL(msg);
    HPGV_TIMING_CONTEXTGLOBAL(msg);
    HPGV_TIMING_SAVELOCAL(1);
    HPGV_TIMING_SAVEGLOBAL(1);
    if (init_timing == false) {
        init_timing = true;
        HPGV_TIMING_NAME(MY_ALL_SLOVE_TIME,          "T_all");
        HPGV_TIMING_NAME(CREATE_BITMAP_TIME,         "T_bitmap");
        HPGV_TIMING_NAME(CREATE_GLOBAL_TREE_TIME,    "T_g_tree");//2
        HPGV_TIMING_NAME(ASSIGN_LOCAL_REGION,        "T_assign");//3
        HPGV_TIMING_NAME(CREATE_SCHEDULE_TIME,       "T_schedule");
        HPGV_TIMING_NAME(LOCAL_TREE_TIME,            "T_l_tree");
        HPGV_TIMING_NAME(CREATE_VTX_ARRAY,           "T_vtx_arry");//6
        HPGV_TIMING_NAME(VERTEX_DISTANCE_TIME,       "T_dist");//7
        HPGV_TIMING_NAME(COM_MEM_TIME,               "T_comm_mem");//8
        HPGV_TIMING_NAME(DIST_LOCAL,                 "T_l_dist");//9
        HPGV_TIMING_NAME(PREPARE_SEND_BUFFER,        "T_buffer");
        HPGV_TIMING_NAME(COMM_PHASE_1,               "T_exg1");
        HPGV_TIMING_NAME(COMPUT_REMOTE_DIST,         "T_c_dist");
        HPGV_TIMING_NAME(COMM_PHASE_2,               "T_exg2");
        HPGV_TIMING_NAME(UPDATE_DIST,                "T_u_dist");
        HPGV_TIMING_NAME(MY_SEND_BYTE1,              "C_send1");
        HPGV_TIMING_NAME(MY_RECV_BYTE1,              "C_recv1");
        HPGV_TIMING_NAME(MY_SEND_BYTE2,              "C_send2");
        HPGV_TIMING_NAME(MY_RECV_BYTE2,              "C_recv2");
        HPGV_TIMING_NAME(COMPUTE_DIST_VOL_ALL_TIME,  "T_vol_all");
        HPGV_TIMING_NAME(COMPUTE_DIST_VOL_STEP_TIME, "T_vol_step");
        HPGV_TIMING_NAME(LOAD_GEOMETRY_TIME,           "T_load");
        HPGV_TIMING_NAME(T_g_init,                   "T_g_init");
        HPGV_TIMING_NAME(T_g_2,                      "T_g_2");
        HPGV_TIMING_NAME(T_g_m,                      "T_g_m");
        HPGV_TIMING_NAME(T_g_key,                    "T_g_key");
        HPGV_TIMING_NAME(T_g_child,                  "T_g_child");
        HPGV_TIMING_NAME(T_g_collect,                "T_g_collect");
        HPGV_TIMING_NAME(C_global_tree_h,            "C_global_tree_h");
        HPGV_TIMING_NAME(C_global_tree_size,         "C_global_tree_size");
        HPGV_TIMING_NAME(T_g_isoblock,               "T_g_isoblock");
        HPGV_TIMING_NAME(T_g_proc,                   "T_g_proc");
        HPGV_TIMING_NAME(update_time, "T_update");
        HPGV_TIMING_NAME(C_leaf_node_changed, "C_leaf_changed");
        HPGV_TIMING_NAME(C_leaf_node_total, "C_leaf_avg_total");
        HPGV_TIMING_NAME(C_pe_changed,    "C_pe_changed");
        HPGV_TIMING_NAME(C_update_comm,   "C_update_comm");
        HPGV_TIMING_NAME(C_nbits_changed, "C_nbits_changed");
        HPGV_TIMING_NAME(T_u_dist, "T_update_dist");
        HPGV_TIMING_COUNT(T_g_m);
        HPGV_TIMING_COUNT(T_g_key);
        HPGV_TIMING_COUNT(T_g_child);
        HPGV_TIMING_COUNT(T_g_collect);
        HPGV_TIMING_COUNT(C_global_tree_size);
        HPGV_TIMING_COUNT(T_g_isoblock);

    }
    return init_timing;
}

