ifndef OPT
    OPT = ON
	#OFF
endif

ifndef DEBUG
    DEBUG =
   	#ON
endif

ifndef SYSTEM
	SYSTEM = LOCAL
	#SYSTEM = HOPPER
	FEATURE_T = GEOMETRY
	#GEOMETRY_BOEING_GEN
	#GEOMETRY
	#POINTCLOUD
	#
endif

ifeq ($(FEATURE_T), POINTCLOUD)
	EXE_NAME = pdist
	CFLAGS += -D POINTCLOUD
	#RUN_DIR = $(SCRATCH)/lifted_T/$(EXE_NAME)
	RUN_DIR = $(SCRATCH)/lifted_T/$(EXE_NAME)
endif
#BOEING777 TEST
ifeq ($(FEATURE_T), GEOMETRY_BOEING_GEN)
	EXE_NAME = geo_dist_vol_debug_scalability
	CFLAGS += -D GEOMETRY_BOEING
	RUN_DIR = $(SCRATCH)/boeing_777_engine/$(EXE_NAME)
endif

ifeq ($(FEATURE_T), GEOMETRY_BOEING)
	EXE_NAME = geo_no_dist_vol_debug_scalability
	CFLAGS += -D GEOMETRY_BOEING
	RUN_DIR = $SCRATCH/boeing_777/$(EXE_NAME)
endif
#SMALL SCALE GEOMETRY TEST.
ifeq ($(FEATURE_T), GEOMETRY)
	CFLAGS += -D GEOMETRY
	EXE_NAME = pdist
	RUN_DIR = $(SCRATCH)/omp_new_lifted/$(EXE_NAME)
	#RUN_DIR = $(SCRATCH)/new_lifted_point/$(EXE_NAME)
	#RUN_DIR = $(SCRATCH)/new_lifted_T/$(EXE_NAME)
	##RUN_DIR = $(SCRATCH)/lifted_T/$(EXE_NAME)
endif
ifeq ($(FEATURE_T), POINTCLOUD_GEN)
	EXE_NAME = synthetic_gen_dist_16x
	CFLAGS += -D POINTCLOUD
endif
ifeq ($(FEATURE_T), GEOMETRY_GEN)
	EXE_NAME = geo_gen_dist_vol
	CFLAGS += -D GEOMETRY
endif


ifeq ($(SYSTEM), TITAN)
	SYSTEM_INFO="******* You're running on Titan. *******"
	CPP = CC
	CFLAGS += -D POINTCLOUD_RES=16
	RUN_DIR = /tmp/work/$(USER)/$(EXE_NAME)
endif

ifeq ($(SYSTEM), LOCAL)
	SYSTEM_INFO="******* You're running on LOCAL. *******"
	CC = mpicc
	CPP = mpic++ -pg
	CFLAGS += -D POINTCLOUD_RES=16
	RUN_DIR = ./$(EXE_NAME)
	#synthetic_gen_dis
	#synthetic_no_dist
	#gen_dist_vol
	#no_dist_vol
endif

ifeq ($(SYSTEM), HOPPER)
	SYSTEM_INFO="******* You're running on Hopper. *******"
	CPP = CC
	CFLAGS += -D POINTCLOUD_RES=16
	#RUN_DIR = /global/homes/j/jrxie/project/distance_field/bin/$(EXE_NAME)
	#synthetic_gen_dis
	#synthetic_no_dist
	#gen_dist_vol
	#no_dist_vol
endif

ifeq ($(SYSTEM), ANL)
	SYSTEM_INFO="******* You're running on ANL IBM Bluegene. *******"
	CC = mpicc
	CPP = mpicxx
	CFLAGS += 
	RUN_DIR = ~/jinrong/exec_path_c_dist
endif

ifeq ($(SYSTEM), SANDIA)
    MPI = $(HOME)/local/lib64/mpich2
    INCLUDE =
    LIB = 
    LDFLAGS = -lm 
    CC = $(MPI)/bin/mpicc
    CFLAGS += -Wall
endif

ifeq ($(SYSTEM), LENS)
    CC = mpicc	
    CFLAGS += -DSYS_LENS
    CFLAGS += -Wall
endif

ifeq ($(SYSTEM), FUSION)
    CC = mpicc	
    CPP = mpic++
    #g++ 
    CFLAGS += 
    #-DSYS_JAGUAR
    RUN_DIR =  ~/work2/project/code/parallel
    MPI_ROOT = /soft/mvapich2/1.4-gcc-4.1.2
    MPI_INC = $(MPI_ROOT)/include
    MPI_LIB = $(MPI_ROOT)/lib
endif

ifeq ($(SYSTEM), JAGUARPF)
	SYSTEM_INFO="******* You're running on Jaguar. *******"
    CC = cc	
	CPP =g++ 
    CFLAGS += -DSYS_JAGUAR
    RUN_DIR = ./
    MPI_INC = $(CRAY_MPICH2_DIR)/include
    MPI_LIB = $(CRAY_MPICH2_DIR)/lib
endif


ifeq ($(SYSTEM), JAGUARPF_BOX)
    CC = CC	
    CFLAGS += -DSYS_JAGUAR -DMPICH_SKIP_MPICXX -DMPICH_IGNORE_CXX_SEEK
endif


ifeq ($(SYSTEM), MAGRITTE)
    CC = mpicc	
    CFLAGS += -DSYS_MAGRITTE
    CFLAGS += -Wall
endif

ifeq ($(SYSTEM), SITH)
    CC = mpicc
endif
	
ifeq ($(OPT), ON)    
    CFLAGS += -O3
endif

ifeq ($(DEBUG), ON)
    CFLAGS += -g #-pg
endif



