#ifndef _TRIANGLE_T_H_
#define _TRIANGLE_T_H_
#pragma once
#include "vec3f.h"

typedef struct triangle_idx_t{
    int vtx[3];//index of three consecutive vertex of current triangle.
    int vn[3];//index of normal of three consecutive vertex of current triangle.
}triangle_idx_t;

class triangle_t{
public:
    lily::vec3f v[3];
    lily::vec3f vn[3];//normal vector directly imported from model file.
    lily::vec3f normal;//normal vector of this triangle computed using v1v2 cross v1v3
public:
    triangle_t(void){};
    ~triangle_t(){};
    bool triangle_overlap_sphere(lily::vec3f &pt_center, float radius) const
    {
        //compute triangle center
        //simple schema
        lily::vec3f triangle_center = (v[0]+v[1]+v[2])/3.0f;
        /*
        float distSqrd = (triangle_center-pt_center).lengthSquared();
        return distSqrd < radius*radius;//(triangle_radius + radius);
        */
        float dist = (pt_center - triangle_center).length();
        //radius of minimum sphere that circumscribes the triangle.
        float triangle_radius = (v[0]-triangle_center).length();
        if (dist < (triangle_radius+radius))
        {
            float dist_precise = fabsf(vertex_triangle_distance(pt_center));
            return dist_precise < radius;//(triangle_radius + radius);
        }else{
            return false;
        }
        

    }
    float vertex_triangle_distance(const lily::vec3f &v0) const;
    bool  point_in_triangle_barycentric(const lily::vec3f &P ) const;
    bool point_in_triangle_barycentric_double(const lily::vec3f &Pf) const;

};

#endif

