#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <vector>
#include "./dtree/DError.h"

using namespace std;

int main(int argc, char ** argv)
{
    if (argc != 3) {
        cerr << argv[0] << " input_file out_file" << endl;
        return 0;
    }

    char *input_obj  = argv[1];
    char *output_bin = argv[2];

    cerr << "Open " << input_obj << endl;
    ifstream inf(input_obj);
    assert(inf);

    string term;
    float x, y, z;
    int idx=0;
    int fx, fy, fz;
    int fnx, fny, fnz;
    vector<float> tab_vertex;
    vector<float> tab_vtx_normal;
    vector<int> tab_face;

    cerr << "Read " << input_obj << endl;

    while (!inf.eof())
    {
        inf >> term;

        if (term == "v") {
            inf >> term;
            x = atof(term.c_str());

            inf >> term;
            y = atof(term.c_str());

            inf >> term;
            z = atof(term.c_str());

            tab_vertex.push_back(x);
            tab_vertex.push_back(y);
            tab_vertex.push_back(z);
        }
        if (term == "vn" ){
            inf >> term;
            x = atof(term.c_str());

            inf >> term;
            y = atof(term.c_str());

            inf >> term;
            z = atof(term.c_str());

            tab_vtx_normal.push_back(x);
            tab_vtx_normal.push_back(y);
            tab_vtx_normal.push_back(z);
        }
        if (term == "f") {
            inf >> term;
            fx  = atoi(term.c_str());
            idx = term.rfind("/");
            D_ASSERT(idx != string::npos, "obj file miss normal index info.\n", DERROR_ERROR);
            fnx = atoi(term.substr(idx+1).c_str());

            inf >> term;
            fy  = atoi(term.c_str());
            idx = term.rfind("/");
            D_ASSERT(idx != string::npos, "obj file miss normal index info.\n", DERROR_ERROR);
            fny = atoi(term.substr(idx+1).c_str());

            inf >> term;
            fz = atoi(term.c_str());
            idx = term.rfind("/");
            D_ASSERT(idx != string::npos, "obj file miss normal index info.\n", DERROR_ERROR);
            fnz = atoi(term.substr(idx+1).c_str());

            //vertex index
            tab_face.push_back(fx);
            tab_face.push_back(fy);
            tab_face.push_back(fz);
            //normal index
            tab_face.push_back(fnx);
            tab_face.push_back(fny);
            tab_face.push_back(fnz);
        }
    }
    cerr << tab_vertex.size()/3 << " vertices\n";
    cerr << tab_vtx_normal.size()/3 << " vertex normal\n";
    cerr << tab_face.size()/6 << " faces\n";
    cerr << "Write " << output_bin << endl;

    ofstream outf(output_bin, ios::binary);
    assert(outf);

    int size_tab = 0;

    size_tab = tab_vertex.size()/3;
    outf.write(reinterpret_cast<char *>(&size_tab), sizeof(int));
    outf.write(reinterpret_cast<char *>(tab_vertex.data()), sizeof(float)*3 * size_tab);

    size_tab = tab_vtx_normal.size()/3;
    outf.write(reinterpret_cast<char *>(&size_tab), sizeof(int));
    outf.write(reinterpret_cast<char *>(tab_vtx_normal.data()), sizeof(float)*3 * size_tab);

    size_tab = tab_face.size()/6;
    outf.write(reinterpret_cast<char *>(&size_tab), sizeof(int));
    outf.write(reinterpret_cast<char *>(tab_face.data()), sizeof(int) *6* size_tab);

    outf.close();
}